Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/src/Parameters.cpp	(revision 127)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/src/Parameters.cpp	(revision 128)
@@ -7,4 +7,5 @@
 
 #include "Behavioural/Core/Multi_Execute_loop/Execute_loop/include/Parameters.h"
+#include "Behavioural/include/Allocation.h"
 #include "Common/include/Max.h"
 
@@ -139,13 +140,10 @@
     _nb_execute_unit                            = _nb_functionnal_unit + _nb_load_store_unit;
 
-    _nb_execute_unit_port                       = new uint32_t [_nb_execute_unit];
-    
-    _read_unit_to_execution_unit_table_execute_type = new bool * [_nb_execute_unit];
+    ALLOC1(_nb_execute_unit_port                          ,uint32_t,_nb_execute_unit);
+    ALLOC2(_read_unit_to_execution_unit_table_execute_type,bool    ,_nb_execute_unit,_nb_type);
+
     for (uint32_t i=0; i<_nb_execute_unit; i++)
-      {
-	_read_unit_to_execution_unit_table_execute_type [i] = new bool [_nb_type];
-	for (uint32_t j=0; j<_nb_type; j++)
-	  _read_unit_to_execution_unit_table_execute_type [i][j] = false;
-      }
+      for (uint32_t j=0; j<_nb_type; j++)
+        _read_unit_to_execution_unit_table_execute_type [i][j] = false;
 
     // Fill execute_type
@@ -203,15 +201,15 @@
     uint32_t _max_nb_inst_memory = max<uint32_t>(_nb_inst_memory,_nb_load_store_unit);
 
-    _set_read_unit_source_register_write = new std::set<uint32_t> [_nb_read_unit];
-    _set_read_unit_source_bypass_write   = new std::set<uint32_t> [_nb_read_unit];
-    _set_read_unit_source_bypass_memory  = new std::set<uint32_t> [_nb_read_unit];
-    
-    _read_unit_nb_register_write          = new uint32_t [_nb_read_unit];
-    _read_unit_nb_bypass_write            = new uint32_t [_nb_read_unit];
-    _read_unit_nb_bypass_memory           = new uint32_t [_nb_read_unit];
-
-    _link_read_unit_with_load_store_unit  = new bool ** [nb_read_unit];
-    _link_read_unit_with_write_unit       = new bool *  [nb_read_unit];
-    _link_read_unit_with_thread           = new bool *  [nb_read_unit];
+    ALLOC1(_set_read_unit_source_register_write  ,std::set<uint32_t>,_nb_read_unit);
+    ALLOC1(_set_read_unit_source_bypass_write    ,std::set<uint32_t>,_nb_read_unit);
+    ALLOC1(_set_read_unit_source_bypass_memory   ,std::set<uint32_t>,_nb_read_unit);
+
+    ALLOC1(_read_unit_nb_register_write          ,uint32_t          ,_nb_read_unit);
+    ALLOC1(_read_unit_nb_bypass_write            ,uint32_t          ,_nb_read_unit);
+    ALLOC1(_read_unit_nb_bypass_memory           ,uint32_t          ,_nb_read_unit);
+
+    ALLOC3(_link_read_unit_with_load_store_unit  ,bool              ,_nb_read_unit,_nb_execute_unit,_max_nb_inst_memory);
+    ALLOC2(_link_read_unit_with_write_unit       ,bool              ,_nb_read_unit,_nb_write_unit  );
+    ALLOC2(_link_read_unit_with_thread           ,bool              ,_nb_read_unit,_nb_thread      );
 
     for (uint32_t i=0; i<_nb_read_unit; i++)
@@ -221,15 +219,8 @@
 	_read_unit_nb_bypass_memory  [i] = 0;
 
-	_link_read_unit_with_load_store_unit [i] = new bool * [_nb_execute_unit];
-	_link_read_unit_with_write_unit      [i] = new bool   [_nb_write_unit];
-	_link_read_unit_with_thread          [i] = new bool   [_nb_thread];
-
 	for (uint32_t j=0; j<_nb_execute_unit; j++)
-	  {
-	    _link_read_unit_with_load_store_unit [i][j] = new bool [_max_nb_inst_memory];
-
-	    for (uint32_t k=0; k<_max_nb_inst_memory; k++)
-	      _link_read_unit_with_load_store_unit [i][j][k] = false;
-	  }
+          for (uint32_t k=0; k<_max_nb_inst_memory; k++)
+            _link_read_unit_with_load_store_unit [i][j][k] = false;
+
 	for (uint32_t j=0; j<_nb_write_unit; j++)
 	  _link_read_unit_with_write_unit [i][j] = false;
@@ -594,13 +585,13 @@
     delete    _param_read_unit [i];
     delete [] _param_read_unit;
-
+    
     for (uint32_t i=0; i<_nb_execute_unit; i++)
       {
         uint32_t x = _translate_num_execute_unit [i];
-
+        
         if (_is_load_store_unit [i] == false)
           delete _param_functionnal_unit [x];
         else
-          delete _param_load_store_unit [x];
+          delete _param_load_store_unit  [x];
       }
     delete [] _param_functionnal_unit;
@@ -613,17 +604,24 @@
     delete    _param_register_unit;
 
-    delete [] _read_unit_to_execution_unit_table_execute_type;
-    delete [] _read_unit_nb_register_write;
-    delete [] _read_unit_nb_bypass_write;
-    delete [] _read_unit_nb_bypass_memory;
-    delete [] _set_read_unit_source_register_write ;
-    delete [] _set_read_unit_source_bypass_write   ;
-    delete [] _set_read_unit_source_bypass_memory  ;
-    delete [] _link_read_unit_with_load_store_unit;
-    delete [] _link_read_unit_with_write_unit;
-    delete [] _link_read_unit_with_thread;
-    delete [] _is_load_store_unit;
-    delete [] _translate_num_execute_unit;
-    delete [] _nb_execute_unit_port;
+    uint32_t _nb_thread = get_nb_thread(_nb_context,
+					_nb_front_end,
+					_nb_ooo_engine);
+    uint32_t _max_nb_inst_memory = max<uint32_t>(_nb_inst_memory,_nb_load_store_unit);
+
+    DELETE2(_link_read_unit_with_thread           ,_nb_read_unit,_nb_thread      );
+    DELETE2(_link_read_unit_with_write_unit       ,_nb_read_unit,_nb_write_unit  );
+    DELETE3(_link_read_unit_with_load_store_unit  ,_nb_read_unit,_nb_execute_unit,_max_nb_inst_memory);
+
+    DELETE1(_read_unit_nb_bypass_memory           ,_nb_read_unit);
+    DELETE1(_read_unit_nb_bypass_write            ,_nb_read_unit);
+    DELETE1(_read_unit_nb_register_write          ,_nb_read_unit);
+
+    DELETE1(_set_read_unit_source_bypass_memory   ,_nb_read_unit);
+    DELETE1(_set_read_unit_source_bypass_write    ,_nb_read_unit);
+    DELETE1(_set_read_unit_source_register_write  ,_nb_read_unit);
+
+    DELETE2(_read_unit_to_execution_unit_table_execute_type,_nb_execute_unit,_nb_type);
+    DELETE1(_nb_execute_unit_port                          ,_nb_execute_unit);
+
     log_printf(FUNC,Execute_loop,FUNCTION,"End");
   };
